function ajax2(url, data, callback, timeout, errorfunction, type)
{
	postData = data;

	var xmlHttpObject = createXMLHTTPObject();

	var c = '';
	if (typeof(device) != 'undefined' && typeof(device.cordova) != 'undefined')
	{
		c = device.cordova;
	}
	var postData = postData + '&v='+version+'&app='+(desktop ? 0 : 1)+'&c='+c+'&users_id='+getCookie('users_id');

	var method = 'GET';
	if(type == 'post')
	{
		method = 'POST';
	}
	else
	{
		url += '?'+postData+'&rand='+new Date().getTime();
	}

	xmlHttpObject.open(method, url, true);

	if(timeout)
	{
		xmlHttpObject.timeout = timeout;
	}

	if(typeof(errorfunction) == 'function')
	{
		xmlHttpObject.ontimeout = errorfunction;
		xmlHttpObject.onerror = errorfunction;
	}

	if(type == 'post')
	{
		xmlHttpObject.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	}

	xmlHttpObject.onreadystatechange = function()
	{
		if(this.readyState == 4)
		{
			if(this.status == 200 || this.status == 304)
			{
				/** Success **/
				try
				{
					var json = JSON.parse(this.responseText);
				}
				catch(e)
				{
					console.dir(e);
				}

				if(typeof(callback) == 'function')
				{
					callback(json);
				}
			}
			else
			{
				/** Failure **/
				if(typeof(errorfunction) == 'function')
				{
					errorfunction();
				}
			}
		}
	};

	if(type == 'post')
	{
		xmlHttpObject.send(postData);
	}
	else
	{
		xmlHttpObject.send();
	}
}

var XMLHttpFactories = [
	function () {return new XMLHttpRequest()},
	function () {return new ActiveXObject('Msxml2.XMLHTTP')},
	function () {return new ActiveXObject('Msxml3.XMLHTTP')},
	function () {return new ActiveXObject('Microsoft.XMLHTTP')}
];

function createXMLHTTPObject()
{
	var xmlhttp = false;
	for (var i=0;i<XMLHttpFactories.length;i++)
	{
		try
		{
			xmlhttp = XMLHttpFactories[i]();
		}
		catch (e)
		{
			continue;
		}
		break;
	}
	return xmlhttp;
}


// global xmlhttprequest object
var xmlHttp = new Array();

/** AJAX functions **/

// constants
var REQUEST_GET        = 0;
var REQUEST_XML        = 1;
var REQEST_POST        = 2;
var REQUEST_HEAD       = 3;

function getXMLRequester()
{
    var r = false;

    // try to create a new instance of the xmlhttprequest object        
    try
    {
        // Internet Explorer version < 7
		if (window.ActiveXObject && !window.XMLHttpRequest)
		{
	        for(var i=4;i;i--)
	        {
	            try {
	                // loading of a newer version of msxml dll (msxml3 - msxml5) failed
	                // use fallback solution
	                // old style msxml version independent, deprecated
	                if( i == 2 )
	                {
	                    r = new ActiveXObject("Microsoft.XMLHTTP");
	                }
	                // try to use the latest msxml dll
	                else
	                {
	                    r = new ActiveXObject("Msxml2.XMLHTTP." + i + ".0");
	                }
	                break;
	            }
	            catch(excNotLoadable)
	            {
	                r = false;
	            }
			}
		}
        // Mozilla, Opera und Safari
        else if(window.XMLHttpRequest)
        {
            r = new XMLHttpRequest();
        }
    }
    catch(excNotLoadable)
    {
        r = false;
    }
    return r;
}


var timeouts = new Array();
var errorfunctions = new Array();

function destroyold(thisindex)
{
	if(xmlHttp[thisindex] && xmlHttp[thisindex].readyState)
	{
		if(debug)
		{
			console.log('timeout');
		}
		block_buttons = false;
		if(errorfunctions[thisindex])
		{
			errorfunctions[thisindex]('timeout');
			errorfunctions[thisindex] = -1;
		}
		xmlHttp[thisindex].abort();
		xmlHttp[thisindex] = false;
	}
}

function ajax_destroy_all()
{
	for(var i=0;i<10;i++)
	{
		if (xmlHttp[i])
		{
			xmlHttp[i].abort();
			xmlHttp[i] = false;
		}
	}
}

function ajax(strSource, strData, returnfunction, timeout, errorfunction, uniqueindex)
{
	var thisindex = 0;
	if (uniqueindex)
	{
		thisindex = uniqueindex;
		if(xmlHttp[thisindex] && xmlHttp[thisindex].readyState)
		{
			xmlHttp[thisindex].abort();
			xmlHttp[thisindex] = false;
		}
	}
	else
	{
		for(var i=0;i<10;i++)
		{
			if (!xmlHttp[i])
			{
				thisindex = i;
				i = 10;
			}
		}
	}
	delete errorfunctions[thisindex];
	if (errorfunction)
	{
		errorfunctions[thisindex] = errorfunction;
	}
	clearTimeout(timeouts[thisindex]);
	if (timeout)
	{
		timeouts[thisindex] = setTimeout("destroyold("+thisindex+")", timeout);
	}

    // create a new instance of xmlhttprequest object
    // if it fails, return
    xmlHttp[thisindex] = getXMLRequester();
    if(!xmlHttp[thisindex])
    {
    	return;
    }

    // parse query string
    if(strData && strData.substr(0, 1) == '&' || strData.substr(0, 1) == '?' )
    {
    	strData = strData.substring(1, strData.length);
    }

    // open the connection 
    var c = '';
    if (typeof(device) != 'undefined' && typeof(device.cordova) != 'undefined')
    {
    	c = device.cordova;
    }
    var sc = getlocalstorage('sessioncounter');
    if(!sc)
    {
    	sc = 0;
    }
	var strDataFile = strSource + (strData ? '?' + strData : '' )+'&rand='+new Date().getTime()+'&v='+version+'&app='+(desktop ? 0 : 1)+'&c='+c+'&sc='+sc;
    xmlHttp[thisindex].open('GET', strDataFile, true);
    strData = null;

    // set onload data event-handler
    xmlHttp[thisindex].onreadystatechange = new Function("","processResponse("+thisindex+","+returnfunction+",'"+strSource+"',"+errorfunction+")");

    // send request to server
    xmlHttp[thisindex].send(strData);    // param = POST data

//    return xmlHttp[thisindex];
}

/**
 * process the response data from server
 *
 * @param intID, Integer, ID of this response
 */
function processResponse(thisindex, returnfunction, strSource, errorfunction)
{
    // status 0 UNINITIALIZED open() has not been called yet.
    // status 1 LOADING send() has not been called yet.
    // status 2 LOADED send() has been called, headers and status are available.
    // status 3 INTERACTIVE Downloading, responseText holds the partial data.
    // status 4 COMPLETED Finished with all operations.
    switch(xmlHttp[thisindex].readyState) {
        // uninitialized
        case 0:
        // loading
        case 1:
        // loaded
        case 2:
        // interactive
        case 3:
            break;
        // complete
        case 4:
            // check http status
            if(xmlHttp[thisindex].status == 200 )    // success
            {
            	var responsetext = xmlHttp[thisindex].responseText;
				xmlHttp[thisindex].abort();
				xmlHttp[thisindex] = false;
				if (returnfunction == -1)
				{
					return;
				}
				else if (typeof(returnfunction) == 'function')
				{
					returnfunction(responsetext);
				}
            }
            else
            {
				if(window.handleAJAXError)
				{
//					handleAJAXError(r, intID);
				}
				else
				{
					xmlHttp[thisindex].abort();
					xmlHttp[thisindex] = false;
					if (typeof(errorfunction) == 'function' && errorfunctions[thisindex] != -1)
					{
						errorfunction('receive');
					}
					block_buttons = false;
				}
			}
	}
}