var init_handler = setInterval(function(){init();}, 1000);

setTimeout(function(){init();}, 1);

window.onerror = function(errorMessage, url, line)
{
	console.log(errorMessage);
	if(debug)
	{
		alert(errorMessage);
		alert('file: '+url+':'+line);
	}
};

function init()
{
	if(typeof(default_loaded) == 'undefined' || typeof(init_loaded) != 'undefined')
	{
		return;
	}
	init_loaded = true;
	clearInterval(init_handler);

	var sessioncounter = getlocalstorage('sessioncounter');
	if(!sessioncounter)
	{
		sessioncounter = 0;
	}
	sessioncounter++;
	setlocalstorage('sessioncounter', sessioncounter);

	if(getlocalstorage('types_speedtraps') != 1 && getlocalstorage('types_speedtraps') != -1)
	{
		setlocalstorage('types_speedtraps', 1);
		setlocalstorage('types_trafficjam', 1);
		setlocalstorage('types_roadwork', 1);
		setlocalstorage('types_roe', 1);
		setlocalstorage('types_speedtraps_alert', 1);
		setlocalstorage('types_trafficjam_alert', 1);
		setlocalstorage('types_roadwork_alert', 1);
		setlocalstorage('types_roe_alert', 1);
	}

	if(!getlocalstorage('version_current'))
	{
		setlocalstorage('version_current', version);
	}
	if(!getlocalstorage('sound_volume')){setlocalstorage('sound_volume', 100);}
	if(!getlocalstorage('ios_bg_access')){setlocalstorage('ios_bg_access', 0);} // 0 = no check, -1 = access denied, 1 = access
	if(!getlocalstorage('native_map_rotate')){setlocalstorage('native_map_rotate', 1);}
//	if(!getlocalstorage('compass')){setlocalstorage('compass', getlocalstorage('native_map_rotate'));} //hvis det er første gang denne variabel bruges, så sættes den til sand når kort-rotation er aktiveret
	if(!getlocalstorage('brightness_default')){setlocalstorage('brightness_default', 80);}
	if(!getlocalstorage('zoom_level')){setlocalstorage('zoom_level', 12);}
	if(!getlocalstorage('brightness_night')){setlocalstorage('brightness_night', 40);}
	if(!getlocalstorage('brightness_autochange')){setlocalstorage('brightness_autochange', 1);}
	if(!getlocalstorage('alert_ignore')){setlocalstorage('alert_ignore', 0);}
	if(!getlocalstorage('alert_distance')){setlocalstorage('alert_distance', 4);}
	if(!getlocalstorage('followme_auto')){setlocalstorage('followme_auto', 1);}
	if(!getlocalstorage('inactive_min_exit')){setlocalstorage('inactive_min_exit', 20);}
	if(!getlocalstorage('marker')){setlocalstorage('marker', 'arrow');}
	if(!getlocalstorage('extras_hide_redmaden')){setlocalstorage('extras_hide_redmaden', -1);}
	setlocalstorage('last_gps_received', new Date().getTime());
	setlocalstorage('time_last_active', new Date().getTime());
	global_container['time_turned_on']		= new Date();
	global_container['gps_received']		= 0;
	global_container['speed_available']		= 0;
	global_container['speed_actual']		= 0;
	global_container['speed_when_placing']	= 0;
	global_container['circle_info_open']	= false;

	zoom_current = getlocalstorage('zoom_level');

	sounds_custom = {
		aliensiren1: 'Alien sirene 1',
		aliensiren2: 'Alien sirene 2',
		elephant: 'Elefant',
		pig: 'Gris',
		horse: 'Hest',
		jaguar: 'Jaguar',
		meow: 'Kat',
		fart: 'Prut',
		sirene: 'Sirene',
		snoring1: 'Snork 1',
		snoring2: 'Snork 2',
		tiger: 'Tiger',
		foghorn: 'T&aring;gehorn',
	}

	if(window.location.href.search(/\?desktop_debug/) > 0)
	{
		desktop = 1;
		onDesktopReady();
	}
	else if(window.location.href.search(/ttp:\/\/192/) > 0 || window.location.href.search(/ttps:\/\//) > 0 || window.location.href.search(/\?desktop/) > 0)
	{
		ajaxdomain = '';
		desktop = 1;
		onDesktopReady();
	}
	else
	{
		//mobile - onMobileReady() kaldes via listener deviceready

		var fileref = document.createElement('script');
		fileref.setAttribute('type', 'text/javascript')
		fileref.setAttribute('src', 'cordova.js');
		document.getElementsByTagName('head')[0].appendChild(fileref);

		document.addEventListener('deviceready', onMobileReady, false);
		document.addEventListener('touchmove', onTouchMove); //Listen for movement
		document.addEventListener('touchend', onTouchEnd); //Listen for the user to stop touching
		document.addEventListener('orientationchange', onOrientationChange);
	}
}

// Kun på mobiler

function onMobileReady()
{
	if(device.platform == 'iOS')
	{
		ios_bg_check();
		setTimeout(function()
		{
			var ios_bg_acces = getlocalstorage('ios_bg_access');
			if(ios_bg_acces)
			{
				ios_bg_geo();
			}
		}, 1000);
		if(getlocalstorage('ios_banners_access') !== true)
		{
			setTimeout(function()
			{
				cordova.plugins.diagnostic.getRemoteNotificationTypes(ios_banners_access, function(){});
			}, 2000);
		}
	}

	var map_native_setting = getlocalstorage('map_native_setting');
	if(!map_native_setting)
	{
		// map_native er tom - ikke gemt før
		if(desktop || (device.platform == 'Android' && device.version[0] <= 4) || (device.platform != 'Android' && device.platform != 'iOS'))
		{
			map_native = false;
			setlocalstorage('map_native_setting', -1);
		}
		else
		{
			map_native = true;
			setlocalstorage('map_native_setting', 1);
		}
	}
	else if(map_native_setting == 1)
	{
		map_native = true;
	}
	else if(map_native_setting == -1)
	{
		map_native = false;
	}

	setlocalstorage('gps_button_green', 0);
	setlocalstorage('net_button_green', 0);

	if(device.platform == 'Android')
	{
		
		navigator.splashscreen.hide();
		

		if(device.version.substr(0, 3) > 4.3)
		{
			cordova.plugins.backgroundMode.setDefaults({
				title:  'Fartkontrol.nu',
				ticker: 'Fartkontrol.nu',
				text:	'Forbinder...'
			})
			cordova.plugins.backgroundMode.enable();
		}

		try{
			keepscreenon.enable();
		}
		catch(e)
		{
//			alert(JSON.stringify(e));
		}

		document.addEventListener('pause', onAppPause, false);
		document.addEventListener('resume', onAppResume, false);
		document.addEventListener('backbutton', backKeyDown, true);
	}
	else if(device.platform.match('Win'))
	{
		path = 'www/';
		document.addEventListener('backbutton', backKeyDown, true);
		setTimeout(function()
		{
			try
			{
				window.plugins.insomnia.keepAwake();
			}
			catch(e)
			{
//				alert(JSON.stringify(e));
			}
		}, 5000);
		document.getElementById('map_canvas').style.bottom = '110px';
		document.getElementById('menu_bottom').style.height = '110px';
		document.getElementById('place_other_menu').style.bottom = '111px';
	}
	else if(device.platform == 'iOS')
	{
//		navigator.splashscreen.hide();

		document.addEventListener('pause', onAppPause, false);
		document.addEventListener('resume', onAppResume, false);

		var ios_bg = 1;
		if(getlocalstorage('ios_bg_never') == 1)
		{
			ios_bg = 0;
		}
		setlocalstorage('ios_bg', ios_bg);
		path = '';
		window.plugins.insomnia.keepAwake();
	}
	else
	{
		path = '';
	}


	// automatisk lukning tjekker
	autoclose_interval_handler = setInterval(function()
	{
		console.log('tjekker autoluk');
		if(typeof(global_container['paused']) == 'undefined' || global_container['paused'] == false)
		{
			if(gps_watch_handle)
				{
					if ( device.manufacturer =='HUAWEI'){
					console.log("THIS IS HUAWEI ----stop gps----start gps");
					navigator.geolocation.clearWatch(gps_watch_handle);
					gps_watch();
					
					}
				}
			//console.log("prev position is " + getCookie("prevPos") +" current pos: " +pos[0]);
			//appen er i front
			setlocalstorage('last_gps_received', new Date().getTime());
			return;
		}

		var inactive_min_exit = getCookie('inactive_min_exit');
		if(inactive_min_exit*1 < 1)
		{
			inactive_min_exit = 20;
		}
		var last_gps_received = getlocalstorage('last_gps_received');
		var last_gps_age = (new Date().getTime()-last_gps_received)/1000;

		/*
		console.log('last_gps_received: '+last_gps_received);
		console.log('last_gps_age: '+last_gps_age);
		console.log('inactive_min_exit: '+inactive_min_exit);
		*/

		if(last_gps_received > 0 && last_gps_age > inactive_min_exit*60 && inactive_min_exit != 'never')
		{
			if(!desktop && device.platform == 'iOS')
			{
				if(typeof(global_container['paused']) != 'undefined' && global_container['paused'] == true)
				{
					console.log('lukker nu');
					app_exit_ios();
					//brugeren ønsker at lukke helt
				}
			}
			else
			{
				global_container['popup_active'] = false;
				backKeyDown();
				backKeyDown();
			}
		}
		else
		{
//			console.log('forbliver vågen');
		}
	}, 60000);

	onAppReady();

	// alarm hvis der ikke er netforbindelse
	if(navigator.network.connection.type == Connection.NONE)
	{
		document.getElementById('net_button').style.backgroundColor = '#ff4f4f';
		setTimeout(function()
		{
			if (navigator.network.connection.type == Connection.NONE)
			{
				nicealert('Det ser ikke ud som om din enhed er forbundet til et netværk. Appen fungerer ikke uden netværksadgang.', 'Ingen forbindelse');
			}
		}, 5000);
	}
}


// Kun på desktop
function onDesktopReady()
{
//	document.getElementById('button_apps').style.display = '';
//	document.body.style.overflowY = 'scroll';
	path = '';
	onAppReady();
}

function onAppReady()
{
	// Denne sektion kan slettes efter et par versioner, den konverterer et gemt bluetooth id til at fungere med den nye metode hvor vi kan tillade mere end et device
	if(typeof(getlocalstorage('bluetooth_autostart_id')) === 'string')
	{
		setlocalstorage('bluetooth_autostart_ids', [getlocalstorage('bluetooth_autostart_id')]);
		setnativestorage('bluetooth_autostart_ids', [getlocalstorage('bluetooth_autostart_id')]);
		removelocalstorage('bluetooth_autostart_id');
	}
	
	
	build_dom();

	if(!desktop && device.platform == 'iOS')
	{
		if(map_native)
		{
			// normalt ville vi starte GPS her - men for at sikre mod crash, så udskyder vi det til map_init_native aktiveres (kun for iOS)
			// ligeledes startes fetch_interval og top_fadeout_interval også først i map_init_native
		}
		else
		{
			gps_watch();
			global_container['fetch_interval'] = setInterval(function(){controls_fetch();}, 1000);
			setInterval(top_fadeout_interval, 5000);
		}
	}
	else
	{
		gps_watch();
		global_container['fetch_interval'] = setInterval(function(){controls_fetch();}, 1000);
		setInterval(top_fadeout_interval, 5000);
	}

	menus_build();
	var popup = '';
	popup += '<div class="popup" id="popup">';
	popup += '	<div id="popup_tab_container" style="display:none;">';
	popup += 		'<div style="border:solid 1px gray; border-radius:3px; float:right; margin:3px 3px 0px 0px; padding:8px; font-family:verdana; font-size:11px; cursor:pointer;"'+clickaction('popup_close();')+'>Luk</div>';
	popup += 		'<div class="popup_tab popup_tab_first" id="about"'+clickaction('about_popup(\'about\');')+'>Lyd</div>';
	popup += 		'<div class="popup_tab" id="contact"'+clickaction('about_popup(\'contact\');')+'>Kontakt</div>';
	popup += 		'<div class="popup_tab" id="faq"'+clickaction('about_popup(\'faq\');')+'>OSS</div>';
	popup += 		'<div class="popup_tab" id="gps_net"'+clickaction('about_popup(\'gps_net\');')+'>GPS/NET</div>';
	popup += '	</div>';

	popup += '	<div id="popup_content_container">';
	popup += '		<b>Fartkontrol.nu</b><br /><br />';
	popup += '		<b>S&aring;dan virker det</b><br />';
	popup += '		- Hold denne app &aring;ben mens du k&oslash;rer.<br />';
	popup += '		<div style="height:7px;"></div>';
	popup += '		- Hvis du n&aelig;rmer dig en fartkontrol h&oslash;rer du en alarm (<u onclick="play_sirene();" style="cursor:pointer;">test</u>)<br />';
	popup += '		<div style="height:7px;"></div>';
	popup += '		- Fartkontroller er markeret med store r&oslash;de cirkler.<br />';
	popup += '		<div style="height:7px;"></div>';
	popup += '		- Hvis du m&oslash;der en fartkontrol, tryk &quot;TILF&Oslash;J&quot; og hj&aelig;lp andre brugere af Fartkontrol.nu.<br />';
	popup += '		<div style="height:15px;"></div>';

	popup += '		<div style="height:1px;background-color:gray;"></div>';

	popup += '		<div style="height:15px;"></div>';

	popup += '		<input type="checkbox" id="hide_welcome" /><label for="hide_welcome"> Vis ikke igen</label>';
	popup += '		<input type="button" value="Luk" style="float:right;" onclick="popup_close();" />';
	popup += '	</div>';
	popup += '</div>';

	document.getElementById('popup_container').innerHTML = popup;

	if(typeof(geolocation_available) != 'undefined' && geolocation_available == true)
	{
		document.getElementById('gps_button').style.backgroundColor = '#43d754';

		set_status('gps', 1);
	}

	for(var n=0; n<10; n++)
	{
		setTimeout(function()
		{
			var links = document.getElementsByTagName('a');
			for(var i=0; i<links.length; i++)
			{
				links[i].onclick = function(){url_goto(this.href);return false;}
				links[i].target = '_system';
			}
		}, n*2000);
	}

	if(getlocalstorage('sms_session'))
	{
		vip_check_login();
	}
	else
	{
		document.getElementById('vip_button').style.backgroundColor = '#ff4f4f';
	}

	// DOM på plads.. vi loader map

	if(map_native)
	{
		div = document.getElementById('map_canvas_native');
		div.style.display = '';

		var native_map_rotate = getlocalstorage('native_map_rotate');
		var tilt = native_map_rotate == 1 ? 70 : 0;

		var params = {
			'backgroundColor': 'white',
			'mapType': plugin.google.maps.MapTypeId.ROADMAP,
			'controls': {
				'compass': false,
				'zoom': false
			},
			'gestures': {
				'scroll': true,
				'tilt': true,
				'rotate': true,
				'zoom': true
			},
			'camera': {
				'latLng': new plugin.google.maps.LatLng(56, 11),
				'tilt': tilt,
				'zoom': 8,
				'bearing': 0
			}
		}
		map_bearing_current = 0;
		zoom_current = 8;
		map_native = plugin.google.maps.Map.getMap(div, params);
		map_native.on(plugin.google.maps.event.MAP_READY, map_init_native);

		map_native.on(plugin.google.maps.event.MAP_CLICK, function(latLng)
		{
			top_fadeout_interval();
			brightness_handle(100);
			map_moved();
		});

		map_native.on(plugin.google.maps.event.CAMERA_CHANGE, function(latLng)
		{
			map_bearing_current = latLng.bearing;
			// større zoom = mindre afvigelse nødvendig for at aktivere map_moved
			// maks mulig zoom = 21
			if(!geolocation_available)
			{
				// hvis der ikke er GPS, så kan det kun være touch som har rykket kortet
				brightness_handle(100);
			}

			if(latLng.zoom != zoom_current)
			{
				zoom_current = latLng.zoom;
				extras_zoom_changed();
			}

			if(!native_automove_hashcode[0])
			{
				return;
			}
			else if(global_container['zooming_home'])
			{
				// kameraet er i gang med at zoome ind/hen på egen placering
				return;
			}

			global_container['marker_moved']++;

			var zoom_percission = Math.round(latLng.zoom)-12;
			if(zoom_percission < 1)
			{
				zoom_percission = 1;
			}
			zoom_percission *= zoom_percission;
			var percission = zoom_percission*400;
			if(Math.round(latLng.target.lat*percission) != Math.round(native_automove_hashcode[0]*percission) && Math.round(latLng.target.lng*percission) != Math.round(native_automove_hashcode[1]*percission) && my_car_native_created < new Date().getTime()-1000)
			{
				if(!desktop && device.platform == 'iOS')
				{
					if(global_container['moved_home'] && new Date().getTime() < global_container['moved_home']+1000)
					{
						return;
					}
				}

				setlocalstorage('time_last_active', new Date().getTime());

				if(device.platform == 'Android' && global_container['is_placing'])
				{
					// Android kan ikke registrere orientationchange "live", derfor dette lille fiks. Det er vigtigt at onOrientationChange() køres når man er ved at placere en cirkel
					onOrientationChange();
				}
				top_fadeout_interval();
				brightness_handle(100);
				map_moved();
			}
		});

		map_native.on(plugin.google.maps.event.MAP_CLICK, function(latLng)
		{
			setlocalstorage('time_last_active', new Date().getTime());

			if(device.platform == 'Android' && global_container['is_placing'])
			{
				onOrientationChange();
			}

			top_fadeout_interval();
			brightness_handle(100);
		});
	}
	else
	{
		document.getElementById('map_canvas').style.display = '';
		var fileref = document.createElement('script');
		fileref.setAttribute('type', 'text/javascript')
		fileref.setAttribute('src', 'https://maps.googleapis.com/maps/api/js?callback=map_init&key=AIzaSyAgqXvAiuj2OvorSfWhJq7SfTW9zZSdugI');
		document.getElementsByTagName('head')[0].appendChild(fileref);
	}

//	if(getlocalstorage('version_current') != version)
//	{
//		// viser "what's new"

//        //Disabled for beta

//		setlocalstorage('version_current', version);

//		if(true)
//		{
//			global_container['popup_active'] = true;

//			if(map_native){map_native.setClickable(false);}

//			document.getElementById('popup_container').style.display = '';
//			document.getElementById('popup_tab_container').style.display = 'none';
//			document.getElementById('veil').style.display = '';
//			document.getElementById('veil').style.opacity = 0;

//			var html = '';
//			html += '<b><span style="font-size:18px;">Nyt i appen</span></b>';

//			html += '<div style="background-color:gray; height:1px; margin:9px 0px;"></div>';

//			html += '<div style="margin:9px 0px; font-size:0.9em;">';

//			if(!desktop && device.platform == 'iOS')
//			{
//				html += 	'<img src="images/correct2.png" style="width:25px; height:20px; margin-bottom:-5px; margin-right:10px;">';
//				html += 	'<b style="font-size:1.2em;">Notifikationer ved alarm!</b><br>';
//				html += 	'Nu får du en popup-notifikation ved alarm. Det betyder også at skærmen tænder og/eller du får en synlig notifikation selvom appen er i baggrunden :)<br><br>';
//			}

//			if(!desktop && device.platform == 'Android')
//			{
//				html += 	'<img src="images/correct2.png" style="width:25px; height:20px; margin-bottom:-5px; margin-right:10px;">';
//				html += 	'<b style="font-size:1.2em;">Flere fejlrettelser</b><br>';
//				html += 	'Rettelse til bl.a. "app lukker/crasher".<br><br>';

//				html += 	'<img src="images/correct2.png" style="width:25px; height:20px; margin-bottom:-5px; margin-right:10px;">';
//				html += 	'<b style="font-size:1.2em;">VIP: Tændt/sluk ved bluetooth</b><br>';
//				html += 	'Funktionen har fået en fejlrettelse + kan nu registrere flere forskellige bluetooth enheder.<br><br>';
//			}

//			html += 	'<img src="images/correct2.png" style="width:25px; height:20px; margin-bottom:-5px; margin-right:10px;">';
//			html += 	'<b style="font-size:1.2em;">Flere optimeringer og fejlrettelser</b><br><br>';

////			html += 	'<img src="images/correct2.png" style="width:25px; height:20px; margin-bottom:-5px; margin-right:10px;">';
////			html += 	'<b style="font-size:1.2em;">Mange mindre nyheder</b><br>';
////			html += 	'<u style="cursor:pointer;"'+clickaction('url_goto(\'https://fartkontrol.nu/blog.php?id=5\')')+'>Se alle nyheder og &aelig;ndringer</u><br><br>';

//			html += '</div>';

//			html += '<div style="background-color:gray; height:1px; margin:9px 0px;"></div>';
//			html += '<div'+clickaction('popup_close();')+' style="font-size:26px; text-align:center; color:#dedede; cursor:pointer;">';
//			html += 	'LUK';
//			html += '</div>';

//			document.getElementById('popup_content_container').innerHTML = html;
//		}
//	}
}
function getCurPost()
{
										 
	var onSuccess = function(position) {
     /*    alert('Latitude: '          + position.coords.latitude          + '\n' +
              'Longitude: '         + position.coords.longitude         + '\n' +
              'Altitude: '          + position.coords.altitude          + '\n' +
              'Accuracy: '          + position.coords.accuracy          + '\n' +
              'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
              'Heading: '           + position.coords.heading           + '\n' +
              'Speed: '             + position.coords.speed             + '\n' +
              'Timestamp: '         + position.timestamp                + '\n'); */
			  
			  console.log('Latitude: '          + position.coords.latitude);
    };

    // onError Callback receives a PositionError object
    //
    function onError(error) {
       console.log('code: '    + error.code    + '\n' +
              'message: ' + error.message + '\n', 'fejl');
    }

    navigator.geolocation.getCurrentPosition(onSuccess, onError);							 
}
function build_dom()
{
	var zoom_html = '';
	zoom_html += '<div id="zoom_buttons" style="cursor:pointer; position:absolute; left:0.5em; bottom:'+(map_native ? 2 : 5)+'em; border:solid 1px #dedede; border-radius:2px; background-color:white; width:36px; opacity:0.8;">';
	zoom_html += 	'<div style="height:1em; font-size:1.7em; border-bottom:solid 1px gray; margin:0px; padding:5px 0px 8px 0px; font-weight:bold; color:gray; text-align:center;"'+clickaction('map_zoom(1);')+'>';
	zoom_html += 		'+';
	zoom_html += 	'</div>';
	zoom_html += 	'<div style="height:1em; font-size:1.9em; margin:0px; padding:2px 0px 8px 0px; font-weight:bold; color:gray; text-align:center;"'+clickaction('map_zoom(0);')+'>';
	zoom_html += 		'-';
	zoom_html += 	'</div>';
	zoom_html += '</div>';

	var html = '';
	html += '<div id="menu_header" style="font-family:museo; background-color:#2d4365; color:#fff; height:36px;">';
	html += 	'<div style="display:inline-block; cursor:pointer;"'+clickaction('settings_menu();')+'>';
	html += 		'<img src="images/menu_icon.png" style="width:1.7em; height:1.3em; opacity:1; margin:0.4em 0em 0.5em 0.3em;">';
	html += 	'</div>';
	html += 	'<div id="menu_div" style="display:inline-block; height:18px; padding:10px; color:white; font-size:1em; vertical-align:top; cursor:pointer;"'+clickaction('settings_menu();')+'>';
	html += 		'MENU';
	html += 	'</div>';
	html += 	'<div id="menubutton_vip" style="display:none; height:17px; padding:11px 2px 10px 7px; color:white; border-right:solid 1px #fff; font-size:0.9em; vertical-align:top; cursor:pointer;"'+clickaction('sms_overlay_slidein(\'sms\');')+'>';
	html += 		'VIP&nbsp;';
	html += 		'<div id="vip_button" style="display:inline-block; border-radius:10px; height:10px; width:10px; background-color:gray; margin-right:5px;"></div>';
	html += 	'</div>';
	html += 	'<div id="menubutton_saphe" style="display:none; height:17px; padding:11px 8px 10px 7px; color:white; border-right:solid 1px #fff; font-size:0.9em; vertical-align:top; cursor:pointer;"'+clickaction('sms_overlay_slidein(\'saphe\');')+'>';
	html += 		'Saphe';
	html += 	'</div>';
	html += 	'<div style="padding:0.6em 0.6em 0.6em 0em; margin-left:-0.5em; display:inline-block; float:right; cursor:pointer;"'+clickaction('about_popup(\'gps_net\');')+'>';
	html += 		'<span style="font-size:0.8em; margin-right:10px;">';
	html += 			'<div id="net_button" style="display:inline-block; border-radius:10px; height:10px; width:10px; background-color:gray; margin-right:3px;"></div>';
	html += 			'NET';
	html += 		'</span>';
	html += 		'<span style="font-size:0.8em; margin-right:0px;">';
	html += 			'<div id="gps_button" style="display:inline-block; border-radius:10px; height:10px; width:10px; background-color:gray; margin-right:3px;"></div>';
	html += 			'GPS';
	html += 		'</span>';
	html += 	'</div>';
	html += 	'';
	html += '</div>';

	var circle_info_html = '';
	circle_info_html += '<div id="circle_info_container" style="text-align:left; display:none; background-color:#f0f0f0; border-bottom:solid 1px gray;">';
	circle_info_html += 	'<div style="display:inline-block; width:20%; max-width:100px; color:#f0f0f0; right:0px; position:absolute; height:100%; max-height:140px; text-align:center; cursor:pointer;"'+clickaction('circle_info_window_close()')+'>';
	circle_info_html += 		'<div style="padding-top:25px; height:95px; color:darkgrey; font-size:3em; font-family:verdana;">';
	circle_info_html += 			'&#x2715;';
	//circle_info_html += 			'X';
	circle_info_html += 		'</div>';
	circle_info_html += 	'</div>';
	circle_info_html += 	'<div style="display:inline-block; padding:10px; vertical-align:top;">';
	circle_info_html += 		'<span style="font-size:1.5em;">';
	circle_info_html += 			'<span id="circle_info_title_container"></span>';
	circle_info_html += 			'<span style="opacity:0.3; margin-left:12px; cursor:pointer;"'+clickaction('circle_info_toggle_info()')+'>';
	circle_info_html += 				'<img src="images/info_icon2.png" style="width:25px; margin-bottom:-4px;">';
	circle_info_html += 			'</span>';
	circle_info_html += 			'<span style="opacity:0.3; margin-left:15px; cursor:pointer;" id="circle_info_comments"'+clickaction('circle_comments_overlay()')+'>';
	circle_info_html += 				'<img src="images/comments_icon.png" style="width:30px; margin-bottom:-8px;">';
	circle_info_html += 			'</span>';
	circle_info_html += 			'<span style="opacity:0.3; margin-left:15px; cursor:pointer;" id="circle_info_thumbs"'+clickaction('circle_actions_overlay()')+'>';
	circle_info_html += 				'<img src="images/thumbs_icon.png" style="width:30px; margin-bottom:-7px;">';
	circle_info_html += 			'</span>';
	circle_info_html += 		'</span>';
	circle_info_html += 		'<br>';
	circle_info_html += 		'<div id="circle_info_info" style="display:none; line-height:1.5em; font-size:0.8em; opacity:0.6; margin-right:30px;">';
	circle_info_html += 			'<img src="images/map_marker.png" style="width:13px; margin-left:1px; margin-bottom:-2px; margin-right:4px;">';
	circle_info_html += 			'<span id="circle_info_near_container"></span>';
	circle_info_html += 			'<br>';
	circle_info_html += 			'<img src="images/clock_icon.png" style="width:13px; margin-left:1px; margin-bottom:-2px; margin-right:4px;">';
	circle_info_html += 			'<span id="circle_info_time_container"></span>';
	circle_info_html += 		'</div>';
	circle_info_html += 		'<div style="line-height:1.5em; display:none; font-size:0.8em; opacity:0.8; text-align:left; margin-top:8px;" id="circle_info_ratebuttons">';
	circle_info_html += 			'<div id="circle_info_thanks_button" style="display:inline-block; border:solid 3px green; padding:8px 15px; margin-right:10px; height:20px; border-radius:4px; cursor:pointer;"'+clickaction('circle_rate(\'thanks\')')+'>';
	circle_info_html += 				'Bekr&aelig;ft';
	circle_info_html += 				' (<span id="circle_info_thanks"></span>)';
	circle_info_html += 			'</div>';
	circle_info_html += 			'<div id="circle_info_not_spottet_button" style="display:inline-block; border:solid 3px red; padding:8px 15px; height:20px; border-radius:4px; cursor:pointer;"'+clickaction('circle_rate(\'not_spottet\')')+'>';
	circle_info_html += 				'Ikke spottet';
	circle_info_html += 				' (<span id="circle_info_not_spottet"></span>)';
	circle_info_html += 			'</div>';
	circle_info_html += 		'</div>';
	circle_info_html += 		'<div style="line-height:1.5em; display:none; font-size:0.8em; opacity:0.8; text-align:left; margin-top:8px;" id="circle_info_mybuttons">';
	circle_info_html += 			'<div style="display:inline-block; border:solid 3px grey; padding:8px 15px; margin-right:10px; height:20px; border-radius:4px; cursor:pointer;"'+clickaction('circle_comment_add()')+'>';
	circle_info_html += 				'Skriv kommentar';
	circle_info_html += 			'</div>';
	circle_info_html += 			'<div id="circle_info_remove_button" style="display:inline-block; border:solid 3px red; padding:8px 15px; height:20px; border-radius:4px; cursor:pointer;"'+clickaction('circle_remove()')+'>';
	circle_info_html += 				'Slet';
	circle_info_html += 			'</div>';
	circle_info_html += 			'<div id="circle_info_remove_working" style="display:none; border:solid 3px red; padding:8px 15px; height:20px; border-radius:4px;">';
	circle_info_html += 				'<img src="images/working.gif" style="width:22px; height:22px; margin:-3px -5px -6px -8px;">';
	circle_info_html += 			'</div>';
	circle_info_html += 		'</div>';
	circle_info_html += 	'</div>';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += 	'';
	circle_info_html += '</div>';

	var buttons_html = '';
	buttons_html += 	'<div'+clickaction('move_home_button();')+' id="button_home" style="display:none; cursor:pointer; z-index:1; padding:5px; text-align:center; position:absolute; bottom:'+(map_native ? 20 : 80)+'px; right:0px; margin-right:5px; box-shadow:0px 2px 5px black; background-color:white; opacity:0.7; border:solid 1px gray; border-radius:5px;">';
	buttons_html += 		'<img src="images/crosshair.gif" style="width:35px; margin:-3px -3px -8px -4px;" />';
	buttons_html += 	'</div>';

	html += '<div id="map_canvas" style="text-align:center; display:none;">';
	html += '	<img src="images/working.gif" style="width:30px; margin-top:150px;" />';
	html += '</div>';

	if(!map_native)
	{
		html += circle_info_html;
		html += zoom_html;
		html += buttons_html;
	}
	var banner_top = 15;

	html += '<div id="map_canvas_native" style="text-align:center; display:none;">';
	if(map_native)
	{
		if(device.platform == 'iOS')
		{
			banner_top = 35;
		}
		html += circle_info_html;
		html += zoom_html;
		html += buttons_html;
	}
	html += 	'<span id="add_buttons_native_save" style="display:none; position:absolute; bottom:0px; left:0px; right:0px;">';
	html += 		'<div style="background-color:#64d587; width:30%; background-image:url(images/correct.png);background-size:30px 30px; background-position:5px 10px; background-repeat:no-repeat;"'+clickaction('place_marker_save();')+'>';
	html += 			'<div style="padding-left:30px;">';
	html += 				'GEM';
	html += 			'</div>';
	html += 		'</div>';
	html += 		'<div style="background-color:#f7837f; width:70%; background-image:url(images/false.png);background-size:30px 30px; background-position:10px 10px; background-repeat:no-repeat;"'+clickaction('place_marker_cancel();')+'>';
	html += 			'<div style="padding-left:30px;">';
	html += 				'ANNULLER';
	html += 			'</div>';
	html += 		'</div>';
	html += 	'</span>';
	html += 	'<img src="images/working.gif" style="width:30px; margin-top:150px;" id="working_native">';
// pas på, denne kan få ios til at crashe under opstart - virker som om det går galt hvis man ændrer på indholdet i map_canvas_native mens map_native loader. og der er noget delay på begge dele, så det er svært at tage højde for
// af en eller anden grund fejler det også hvis man fjerne billedet eller sætter display:none fra start?!?!?!?!? måske bare noget cache fejl på min enhed?
	html += 	'<div id="sms_banner_overlay" style="display:none; padding:10px; opacity:0.85; font-size:0.9em; font-family:verdana; overflow-y:hidden; background-color:#012e43; box-shadow:0px 0px 10px black; color:white; position:absolute; top:'+banner_top+'px; right:0px; left:0px; z-index:0; -webkit-transition-duration:.6s; transition-duration:.6s;">';
	html += 	'</div>';
	html += '</div>';

	html += '<div style="text-align:center; display:none;" id="crosshair_red_container">';
	html += 	'<img src="images/crosshair_red.png" style="" id="crosshair_red">';
	html += '</div>';

	html += '<div id="menu_bottom" style="background-color:#2d4365; z-index:2;"></div>';
	html += '<div id="menu_bottom_below" style="background-color:#2d4365; z-index:2; text-align:center; font-size:1.5em; font-family:verdana; display:none;"><div style="opacity:0.1; margin-top:12px;">BEKR&AElig;FT</div></div>';

	html += '<div class="popup_container" id="popup_container" style="display:none;"></div>';

	html += '<audio src="mp3/sirene.mp3" id="alert_mp3"></audio>';

	html += '<div class="veil" style="display:none;" id="veil"'+clickaction('popup_close()')+'></div>';

	html += '<div id="sms_button_container" style="position:absolute; display:none; width:38px; height:38px; border:solid 1px gray; cursor:pointer; box-shadow:black 0px 2px 5px; opacity:0.5; border-radius:5px; background-color:white;"><img src="images/sms_black.png" style="width:30px; height:30px; margin:4px;"></div>';

	html += '<div style="overflow:hidden; -webkit-transition:0.5s; transition:0.5s; left:50%; margin-left:-100px; z-index:1; position:absolute; bottom:0px; width:150px; height:36px; background-image:url(\'images/speedometer.png\'); background-size:150px 70px;" id="speedometer">';
	html += '	<div id="speedometer_speed" style="font-size:50px; color:white; text-align:center; padding-top:11px;">-</div>';
	html += '</div>';

	html += '<div id="place_other_menu" style="display:none;"></div>';

	html += '<div id="debug_container" style="font-size:0.8em; display:none; position:absolute; top:5px; left:36px; width:160px; height:100px; background-color:white; border:solid 2px gray; padding:2px;"></div>';
	html += '<div id="debug_container_background"'+clickaction('this.style.display=\'none\';')+' style="overflow-y:scroll; font-size:0.8em; display:none; position:absolute; top:85px; left:36px; width:260px; height:500px; background-color:white; border:solid 2px gray; padding:2px;"></div>';

	document.body.innerHTML = html;
}

function setlocalstorage(name, value)
{
	var storage = window.localStorage;
	storage.setItem(name, value);
	return;
}

function getlocalstorage(name)
{
	return window.localStorage.getItem(name);
}

function removelocalstorage(name)
{
	window.localStorage.removeItem(name);
}

function clearlocalstorage()
{
	window.localStorage.clear();
}

function setnativestorage(name, value)
{
	NativeStorage.setItem(name, value, function(e){/* */}, function(e){/* */});
	return;
}


function removenativestorage(name)
{
	NativeStorage.remove(name, function(e){console.log("Native storage value removed");}, function(e){console.log("Native storage failed to remove value");});
}




function backKeyDown()
{
	if(global_container['popup_active'] == true)
	{
		if(global_container['history_active'] && document.getElementById('history_is_active_identifier'))
		{
			if(global_container['circle_info_open'])
			{
				circle_info_window_close();
				document.getElementById('popup_container').style.display = '';
				return;
			}
			history_popup_close();
		}
		else
		{
			popup_close();
		}

		return;
	}
	else if(infowindow && infowindow.getMap())
	{
		infowindow.setMap(null);
		return;
	}
	else if(global_container['circle_info_open'])
	{
		circle_info_window_close();
		return;
	}
	else if(document.getElementById('place_other_menu').style.display == '')
	{
		settings_menu(1);
		return;
	}
	else
	{
		if(typeof(global_container['double_back']) == 'undefined' || !global_container['double_back'])
		{
			global_container['double_back'] = true;
			setTimeout(function()
			{
				global_container['double_back'] = false;
				if(!desktop && device.platform.match('Win'))
				{
					document.addEventListener('backbutton', backKeyDown, true);
				}
			}, 3000);
			if(typeof(global_container['paused']) == 'undefined' || global_container['paused'] == false)
			{
				if(!desktop && device.platform.match('Win'))
				{
					document.removeEventListener("backbutton", backKeyDown, false);
				}
				toast('Tryk tilbage igen for at lukke');
			}
		}
		else
		{
			if(typeof(global_container['paused']) != 'undefined' && global_container['paused'] == true)
			{
				toast('Fartkontrol.nu lukket pga. inaktivitet');
			}
			app_exit();
		}
	}
}

function toast(message, duration)
{
	if(duration == 'short')
	{
		duration = 'short';
		var duration_time = 1500;
	}
	else
	{
		duration = 'long';
		var duration_time = 4000;
	}
	position = 'bottom';

	if(desktop)
	{
		message = message.replace('?', '&aelig;');
		message = message.replace('?', '&oslash;');
		message = message.replace('?', '&aring;');
		message = message.replace('?', '&Aelig;');
		message = message.replace('?', '&Oslash;');
		message = message.replace('?', '&Aring;');
		if(document.getElementById('div_toast') && (document.getElementById('div_toast').style.opacity == '1' || document.getElementById('div_toast').style.display == 'inline-block'))
		{
			//gammel toast er synlig - vi bliver n?dt til at fjerne den helt pga **** med transitions
			document.getElementById('div_toast').style.transitionDuration = '';
			document.getElementById('div_toast').style.display = 'none';
			document.getElementById('div_toast').style.opacity = '0';

			var item = document.getElementById('div_toast');
			item.parentNode.removeChild(item);

			clearTimeout(toast_timeout1);
			clearTimeout(toast_timeout2);
		}

		if(!document.getElementById('div_toast'))
		{
			var div = document.createElement('span');
			div.id = 'div_toast';
			div.style.backgroundColor = '#040404';
			div.style.borderRadius = '3px';
			div.style.position = 'absolute';
			div.style.bottom = '15px';
			div.style.padding = '10px 15px';
			div.style.color = 'white';
			div.style.left = '50%';
			div.style.zIndex = '1003';
			document.body.appendChild(div);
		}

		document.getElementById('div_toast').innerHTML = message;
		document.getElementById('div_toast').style.display = 'inline-block';
		document.getElementById('div_toast').style.marginLeft = (document.getElementById('div_toast').clientWidth/2)*-1+'px';
		document.getElementById('div_toast').style.opacity = '1';

		toast_timeout1 = setTimeout(function()
		{
			document.getElementById('div_toast').style.transitionDuration = '1s';
			document.getElementById('div_toast').style.opacity = '0';
		}, duration_time);

		toast_timeout2 = setTimeout(function()
		{
			document.getElementById('div_toast').style.transitionDuration = '';
			document.getElementById('div_toast').style.display = 'none';
		}, duration_time+500);

		return;
	}

	window.plugins.toast.show(message, duration, position, function(a){console.log('toast success: ' + a)}, function(b){if(globals['debug']){alert('toast error: ' + b)}});
}

function app_exit(source)
{
	console.log('app_exit');
	if(source == 'bluetooth' && getlocalstorage('bluetooth_autostop') == -1)
	{
		return;
	}
	
	exiting_now = true;
	if(device.platform == 'iOS')
	{
		var ios_bg = getlocalstorage('ios_bg');
		if(ios_bg == 1)
		{
			if(typeof(bgGeo) != 'undefined')
			{
				bgGeo.stop();
			}
			toast('Du kan nu lukke appen uden den kører i baggrunden');
			setlocalstorage('ios_bg', 0);
		}
		else
		{
			ios_bg_check(true);
			setlocalstorage('ios_bg', 1);
		}
		return;
	}

	ajax_destroy_all();
	if(typeof(gps_watch_handle) != 'undefined')
	{
		navigator.geolocation.clearWatch(gps_watch_handle);
	}
	if(typeof(autoclose_interval_handler) != 'undefined')
	{
		clearInterval(autoclose_interval_handler);
	}
	if(device.platform == 'Android')
	{
		if(typeof(android_bg_options) != 'undefined')
		{
			backgroundGeoLocation.finish();
			backgroundGeoLocation.stop();
		}
		if(device.version.substr(0, 3) > 4.3)
		{
			cordova.plugins.backgroundMode.disable();
		}

		cordova.plugins.notification.local.cancelAll(function(){});

		var vars			= new Object();
		vars['uid']			= getCookie('uid');
		vars['app']			= 1;
		vars['action']		= 'app_exit';
		vars['session_id']	= session_id;
		ajax(ajaxdomain+'/ajax.php', 'json='+JSON.stringify(vars), false, 30000);

		if(source == 'bluetooth')
		{
			toast('Fartkontrol.nu lukket (bluetooth)', 'long');
			setTimeout(function()
			{
				navigator.app.exitApp();
			}, 100);
		}
		else
		{
			navigator.app.exitApp();
		}
	}
}

function app_exit_ios()
{
	if(ios_bg_killed)
	{
//		console.log('dobbelt forsøg på at lukke app?');
	}
	ios_bg_killed = true;

	cordova.plugins.notification.local.clearAll();

	if(typeof(bgGeo) != 'undefined' && bgGeo != false)
	{
		bgGeo.setConfig({
			preventSuspend: false,
		}, function(){
//			console.log("- setConfig success");
		}, function(){
//			console.warn("- Failed to setConfig");
		});

		ios_stop_bg();
		bgGeo.stop();
		bgGeo = false;
	}
	if(map_native)
	{
		if(my_car)
		{
			my_car.remove();
		}
		map_native.remove();
		my_car_native_created = false;
		my_car = false;
	}
	ajax_destroy_all();
	if(typeof(gps_watch_handle) != 'undefined')
	{
		navigator.geolocation.clearWatch(gps_watch_handle);
	}
	if(typeof(autoclose_interval_handler) != 'undefined')
	{
		clearInterval(autoclose_interval_handler);
	}

	document.getElementById('map_canvas').innerHTML = '';

	setTimeout(function()
	{
		window.plugins.insomnia.allowSleepAgain();
	}, 500);

	var vars			= new Object();
	vars['uid']			= getCookie('uid');
	vars['app']			= 1;
	vars['action']		= 'app_exit';
	vars['session_id']	= session_id;
	ajax(ajaxdomain+'/ajax.php', 'json='+JSON.stringify(vars), false, 30000);

//	setTimeout(function()
//	{
//		document.location.href = 'blank.html';
//	}, 5000);
}

function app_started_by_bluetooth()
{
	if(Date.now()-global_container['time_app_start'] < 5000)
	{
		var sound_volume = getlocalstorage('sound_volume');

		var notify_obj = {
			id: 1,
			image:"file://images/icon_big.png",
			icon:"file://images/icon_big.png",
			smallIcon:"res://icon",
			title: 'Fartkontrol.nu startet (bluetooth)',
			text: 'Fartkontrol.nu startet (bluetooth)',
			sound: false,
			ongoing:false
		}

		var sound = 'started_voice';
		if(getlocalstorage('media_player_old') == 1)
		{
			// bemærk - hvis vi tillader almindelig afspilning via Media() så vil lyden blive stjålet af eventuelle bluetooth enheder igen

			sirene_media = new Media(path+'mp3/'+sound+'.mp3');
			sirene_media.play();
			sirene_media.setVolume(sound_volume/100);
		}
		else
		{
			notify_obj.sound = 'file://mp3/'+sound+'.mp3';
		}

		cordova.plugins.notification.local.schedule(notify_obj);

		setTimeout(function()
		{
			cordova.plugins.notification.local.cancel([1], function () {
				// Notifications were cancelled
			});
		}, 15000);

		/*
		navigator.notification.vibrate(500);
		setTimeout(function()
		{
			navigator.notification.vibrate(500);
		}, 1000);
		toast('Fartkontrol.nu startet/stoppet via bluetooth', 'long');
		*/
	}
}

var isTouching	= false;
var hasMoved	= 0;
var todo		= '';
var touchstart_coordinates = new Array();

function onTouchStart(e, todo_now)
{
	document.getElementById('menu_header').style.visibility = 'visible';
//	document.getElementById('map_canvas').style.top = '20px';
	if(isTouching) return;
	todo = todo_now;
	isTouching	= new Date().getTime();
	touchstart_coordinates[0] = e.pageX;
	touchstart_coordinates[1] = e.pageY;
}

function onTouchMove(e)
{
	hasMoved += 1;
}

function onScroll(e)
{
	todo = '';
	isTouching = false;
	hasMoved = 0;
	touchstart_coordinates = new Array();
}

function onTouchEnd(e)
{
	setlocalstorage('time_last_active', new Date().getTime());
	setlocalstorage('last_gps_received', new Date().getTime());

	var moved = 'invalid';
	if (e.pageX)
	{
		var moved = touchstart_coordinates[0] - e.pageX;
		moved += touchstart_coordinates[1] - e.pageY;
		if (moved < 0)
		{
			moved *= -1;
		}
	}

	var touchtime = new Date().getTime()-isTouching;
	if((hasMoved == 0 || touchtime < 0 || (!isNaN(moved) && moved != 'invalid' && moved < 20)) && todo)
	{
		eval(todo);
		todo = '';
	}
	isTouching = false;
	hasMoved = 0;
	touchstart_coordinates = new Array();
}
window.onscroll = onScroll;

function trim (str)
{
	str = str.replace(/^\s+/, '');
	for (var i = str.length - 1; i >= 0; i--) {
		if (/\S/.test(str.charAt(i))) {
			str = str.substring(0, i + 1);
			break;
		}
	}
	return str;
}

function reload_current()
{
	eval(global_container['frame'])(global_container['currently_showing_id']);
}

function nicealert(message, title)
{
	if (desktop)
	{
		alert(message);
	}
	else
	{
		navigator.notification.alert(message, false, title);
	}
}

function top_fadeout_interval()
{
	// hvis net og gps er grøn + vi ser skærmen i landscape, så skjuler vi topbaren efter 10-15 sek... og viser den igen når der røres ved skærmen
	if(getlocalstorage('lock_topmenu') == 1 || global_container['circle_info_open'])
	{
		return;
	}

	if(window.innerWidth < window.innerHeight || global_container['status_actual'] != 1)
	{
		// topbaren skal vises
		document.getElementById('veil').style.top = '36px';
		document.getElementById('map_canvas_native').style.top = '36px';
		document.getElementById('map_canvas').style.top = '36px';
		document.getElementById('menu_header').style.visibility = 'visible';
		if(!map_native)
		{
			google.maps.event.trigger(map, 'resize');
		}
		return;
	}

	var last_active = getlocalstorage('time_last_active');
	var milisec_inactive = new Date().getTime()-last_active;
	if(milisec_inactive > 10000)
	{
		// skjuler
		document.getElementById('veil').style.top = '-3em';
		document.getElementById('map_canvas_native').style.top = '0em';
		document.getElementById('menu_header').style.visibility = 'hidden';
		document.getElementById('map_canvas').style.top = '-20px';
	}
	else
	{
		// viser
		document.getElementById('veil').style.top = '36px';
		document.getElementById('map_canvas_native').style.top = '36px';
		document.getElementById('map_canvas').style.top = '36px';
		document.getElementById('menu_header').style.visibility = 'visible';
	}
	if(!map_native)
	{
		google.maps.event.trigger(map, 'resize');
	}
}

function onOrientationChange()
{
	setlocalstorage('time_last_active', new Date().getTime());

	top_fadeout_interval();
	brightness_handle(100);

	// i tilfælde af, at man har ændret roation på sin enhed (bruges kun når man tilføjer kontrol)
	var height = document.getElementById('map_canvas_native').clientHeight;
	document.getElementById('crosshair_red_container').style.marginTop = Math.round(height/2)-(device.platform == 'Android' ? 24 : 24)+'px';
}
